unit lcmp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, IniFiles, ComCtrls, ShellAPI, ExtCtrls, Filectrl;

type
  TForm1 = class(TForm)
  EditSrc: TEdit;
  EditDst: TEdit;
  EditResult: TEdit;
  ButtonSrc: TButton;
  ButtonDst: TButton;
  ButtonResult: TButton;
  ButtonExecute: TButton;
  OpenDialog1: TOpenDialog;
  ProgressBar1: TProgressBar;
  LabelSrc: TLabel;
  LabelDst: TLabel;
  LabelResult: TLabel;
  LabelProcess: TLabel;
  RadioGroupListName: TRadioGroup;
  RadioGroupView: TRadioGroup;
  RadioGroupType: TRadioGroup;
  CheckExpandUNCName: TCheckBox;
  ButtonClose: TButton;
  procedure ButtonSrcClick(Sender: TObject);
  procedure ButtonDstClick(Sender: TObject);
  procedure ButtonExecuteClick(Sender: TObject);
  procedure FormCreate(Sender: TObject);
  procedure ApplicationMessage(var Msg: TMsg; var Handled:Boolean);
  procedure RadioGroupListNameClick(Sender: TObject);
  procedure ButtonResultClick(Sender: TObject);
  procedure OrgCmp;
  procedure MkBat(Opt: String);
  procedure PutHeader;
  function SelectFile(LastFileName: String): String;
  function CheckExists(): Integer;
  function GetFileInf(Title, FileName: String): String;
  procedure ButtonCLoseClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ButtonExecuteClick(Sender: TObject);

var
  IniFile : TIniFile;
const
  X = 's(&X)';
begin
  IniFile := TIniFile.Create(AnsiLowerCase(ChangeFileExt(ParamStr(0),'.ini')));
  IniFile.WriteString('EditBox','SrcFileName',EditSrc.Text);
  IniFile.WriteString('EditBox','DstFileName',EditDst.Text);
  IniFile.WriteString('EditBox','ResultFileName',EditResult.Text);
  IniFile.WriteBool('Option','ExpandUNCName',CheckExpandUNCName.Checked);
  IniFile.WriteInteger('Option','CompareType',RadiogroupType.ItemIndex);
  IniFile.WriteInteger('Option','ResultView',RadiogroupView.ItemIndex);
  IniFile.Free;

  if CheckExists <> 0 then exit;
  if ButtonExecute.Caption = X then
    ButtonExecute.Caption := 'f(&X)'
  else
  begin
    ButtonExecute.Caption := X;
    exit;
  end;
  PutHeader;
  Case RadioGroupType.ItemIndex of
  0:begin
    OrgCmp;
    end;
  1:begin
    MkBat('');
    end;
  2:begin
    MkBat('/b');
    end;
  end;
  ButtonExecute.Caption := X;
  if ParamCount <> 0 then
    exit;

  Case RadioGroupView.ItemIndex of
  0:begin
    ShellExecute
    (Handle,'Open'
     ,PChar(EditResult.Text)
     ,NIL,NIL,SW_SHOW);
    end;
  1:begin
    ShellExecute
    (Handle,'open'
     ,PChar(ExtractFilePath(EditResult.Text))
     ,NIL,NIL,SW_SHOW);
    end;
  end;

end;

procedure TForm1.FormCreate(Sender: TObject);

var
  IniFile: TIniFile;
begin
  DragAcceptFiles(EditSrc.Handle, True);
  DragAcceptFiles(EditDst.Handle, True);
  DragAcceptFiles(EditResult.Handle, True);
  Application.OnMessage := ApplicationMessage;
  LabelProcess.Caption := '';
  if ParamCount >= 3 then
  begin
    EditSrc.Text := ExpandUNCFileName(ParamStr(1));
    EditDst.Text := ExpandUNCFileName(ParamStr(2));
    EditResult.Text := ExpandUNCFileName(ParamStr(3));
    RadiogroupType.ItemIndex := Pos(UpperCase(ParamStr(4)),'TB');
    ButtonExecuteClick(Sender);
    Application.Terminate;
  end else
  begin
    IniFile := TIniFile.Create(ChangeFileExt(ParamStr(0),'.ini'));
    with IniFile do
      begin
        EditSrc.Text := ReadString('EditBox','SrcFileName','');
        EditDst.Text := ReadString('EditBox','DstFileName','');
        EditResult.Text := ReadString('EditBox','ResultFileName','');
        CheckExpandUNCName.Checked := ReadBool('Option','ExpandUNCName',TRUE);
        RadiogroupType.ItemIndex := ReadInteger('Option','CompareType',0);
        RadiogroupView.ItemIndex := ReadInteger('Option','ResultView',0);
      end;
    IniFile.Free;
  end;

end;

procedure TForm1.ApplicationMessage(var Msg: TMsg; var Handled:
Boolean);
var
  FileName: array [0..256] of Char;
  EditArray: array [1..3] of TEdit;
  I: Integer;
begin
  EditArray[1] := EditSrc;
  EditArray[2] := EditDst;
  EditArray[3] := EditResult;
  for i := 1 to 3 do begin
    if (Msg.message = WM_DROPFILES) and
       (Msg.hwnd = EditArray[i].Handle) then
    begin
      DragQueryFile(Msg.wParam, 0, FileName, SizeOf(FileName)-1);
      EditArray[i].Text := FileName;
      DragFinish(Msg.wParam);
      Handled := True;
      Exit;
    end;
  end;
end;

procedure TForm1.RadioGroupListNameClick(Sender: TObject);
begin
  if RadioGroupListName.ItemIndex = 0 then
  begin
    EditResult.Text :=
    ExtractFilePath(ParamStr(0))
    +'result.txt';
  end;
  if RadioGroupListName.ItemIndex = 1 then
  begin
    EditResult.Text :=
    ExtractFilePath(ParamStr(0))
    +ChangeFileExt(ExtractFileName(EditDst.Text),'')
    +'-'
    +ChangeFileExt(ExtractFileName(EditSrc.Text),'.txt');
  end;
end;

procedure TForm1.ButtonSrcClick(Sender: TObject);
begin
  EditSrc.Text := SelectFile(EditSrc.Text);
end;

procedure TForm1.ButtonDstClick(Sender: TObject);
begin
  EditDst.Text := SelectFile(EditDst.Text);
end;

procedure TForm1.ButtonResultClick(Sender: TObject);
begin
  EditResult.Text := SelectFile(EditResult.Text);
end;

function TForm1.SelectFile(LastFileName: String): String;
  var
  IniFile: TIniFile;
  begin
    IniFile := TIniFile.Create(AnsiLowerCase(ChangeFileExt(ParamStr(0),'.ini')));
    with IniFile do
    begin
      OpenDialog1.Filter := ReadString('OpenDialog','Filter','');
    end;
    IniFile.Free;
    OpenDialog1.InitialDir := ExtractFilePath(LastFileName);
    if OpenDialog1.Execute then
      result := OpenDialog1.FileName
      else
      result := LastFileName;
  end;

procedure TForm1.MkBat(Opt: string);
var
  F: TextFile;
  S: String;
  SI :TStartupInfo;
  PI :TProcessInformation;
begin
  S := 'lcmp.bat';
  AssignFile(F,S);
  ReWrite(F);
  Opt := 'fc.exe '+Opt+' "'
    +EditSrc.Text+'" "'
    +EditDst.Text+'" >> "'
    +EditResult.Text+'"';
  Writeln(F,Opt);
  CloseFile(F);
  GetStartupInfo(SI);
  If not CreateProcess(PChar(S), nil, nil, nil,
                       False,  CREATE_DEFAULT_ERROR_MODE,nil, nil, SI, PI) Then
     raise Exception.Create('Exec Error ' + IntToStr(GetLastError));
  while WaitForSingleObject(PI.hProcess, 0) = WAIT_TIMEOUT do
    Application.ProcessMessages;
  DeleteFile(ChangeFileExt(S,'.log'));
  RenameFile(S,ChangeFileExt(S,'.log'));

end;

procedure TForm1.OrgCmp;
var
  S: String;
  SrcIndex : Integer;
  DstIndex : Integer;
  ProgressCount : Integer;
  OldList: TStrings;
  NewLIst: TStrings;
  DelList: TStrings;
  AddLIst: TStrings;
  F: TextFile;
const
  X = 's(&X)';
begin
  OldList := TStringList.Create;
  NewList := TStringList.Create;
  DelList := TStringList.Create;
  AddList := TStringList.Create;
  try
    OldList.LoadFromFile(EditSrc.Text);
    NewList.LoadFromFile(EditDst.Text);
    ButtonSrc.Enabled := False;
    ButtonDst.Enabled := False;
    ButtonResult.Enabled := False;
    ButtonClose.Enabled := False;
    EditSrc.Enabled := False;
    EditDst.Enabled := False;
    EditResult.Enabled := False;
    CheckExpandUNCName.Enabled := False;
    RadioGroupType.Enabled := False;
    RadioGroupListName.Enabled := False;
    RadioGroupView.Enabled := False;
    LabelProcess.Caption := 'eLXg...';
    LabelProcess.Refresh;
    ProgressBar1.Min := 0;
    ProgressBar1.Max := OldList.Count;
    ProgressBar1.Step := OldList.Count div 100;
    if ProgressBar1.Step = 0 then ProgressBar1.Step := 1;
    SrcIndex := 0;
    for ProgressCount := 0 to ProgressBar1.Max -1 do
    begin
      Application.ProcessMessages;
      if ButtonExecute.Caption = X then
      begin
        DelList.Clear;
        DelList.Add('f܂');
        break;
      end;
      if ProgressCount mod ProgressBar1.Step = 0 then
        ProgressBar1.StepIt;
      S := OldList[SrcIndex];
      SrcIndex := SrcIndex+1;
      if S <> '' then
      begin
        with NewList do
        begin
          DstIndex := IndexOf(S);
          if  DstIndex = -1 then
          begin
            DelList.Add(S);
          end else
          begin
            SrcIndex := SrcIndex -1;
            OldList.Delete(SrcIndex);
            NewList.Delete(DstIndex);
          end;
        end;
      end;
    end;
    LabelProcess.Caption := 'VeLXg...';
    LabelProcess.Refresh;
    ProgressBar1.Min := 0;
    ProgressBar1.Max := NewList.Count;
    ProgressBar1.Step := OldList.Count div 100;
    if ProgressBar1.Step = 0 then ProgressBar1.Step := 1;
    SrcIndex := 0;
    for ProgressCount := 0 to ProgressBar1.Max -1 do
    begin
      Application.ProcessMessages;
      if ButtonExecute.Caption = X then
      begin
        AddList.Clear;
        AddList.Add('f܂');
        break;
      end;
      if ProgressCount mod ProgressBar1.Step = 0 then
      ProgressBar1.StepIt;
      S := NewList[SrcIndex];
      SrcIndex := SrcIndex+1;
      if S <> '' then
      begin
        with OldList do
        begin
          DstIndex := IndexOf(S);
          if  DstIndex = -1 then
          begin
            AddList.Add(S);
          end else
          begin
            SrcIndex := SrcIndex -1;
            NewLIst.Delete(SrcIndex);
            OldList.Delete(DstIndex);
          end;
        end;
      end;
    end;

    AssignFile(F,EditResult.Text);
    Append(F);
    LabelProcess.Caption := '폜R[h...';
    Writeln(F,#13+#10+'  r폜ꂽR[h'+#13+#10
             +StringOfChar('-',32));
    ProgressBar1.Min := 0;
    ProgressBar1.Max := DelList.Count;
    for SrcIndex :=0 to DelList.Count - 1 do
    begin
        Writeln(F,DelList[SrcIndex]);
    end;
    Writeln(F,StringOfChar('-',32)+#13+#10
             +Format('  폜 %d s',[DelList.Count]));
    LabelProcess.Caption := 'ǉR[h...';
    Writeln(F,#13+#10+'  r֒ǉꂽR[h'+#13+#10
             +StringOfChar('-',32));
    ProgressBar1.Min := 0;
    ProgressBar1.Max := AddList.Count;
    for SrcIndex :=0 to AddList.Count - 1 do
    begin
        Writeln(F,AddList[SrcIndex]);
    end;
    Writeln(F,StringOfChar('-',32)+#13+#10
             +Format('  ǉ %d s',[AddList.Count]));
    CloseFile(F);
  finally
    LabelProcess.Refresh;
    OldList.Free;
    NewList.Free;
    DelList.Free;
    AddList.Free;
  end;
  LabelProcess.Caption := '';
  LabelProcess.Refresh;
  ProgressBar1.Position := 0;

  ButtonSrc.Enabled := True;
  ButtonDst.Enabled := True;
  ButtonResult.Enabled := True;
  ButtonClose.Enabled := True;
  EditSrc.Enabled := True;
  EditDst.Enabled := True;
  EditResult.Enabled := True;
  CheckExpandUNCName.Enabled := True;
  RadioGroupType.Enabled := True;
  RadioGroupListName.Enabled := True;
  RadioGroupView.Enabled := True;

end;

function TForm1.CheckExists(): Integer;
var
  S : String;
begin
  result := 0;
  if FileExists(EditSrc.Text) = false then
  begin
    ShowMessage(EditSrc.Text+'͌܂');
    result := 1;
  end;
  if FileExists(EditDst.Text) = false then
  begin
    ShowMessage(EditDst.Text+'͌܂');
    result := 1;
  end;
  S := ExtractFilePath(EditResult.Text);

  if DirectoryExists(S) = false then
  begin
    ShowMessage('tH_ '+S+' ͌܂');
    result := 1;
  end;

end;

procedure TForm1.PutHeader();
var
  F: TextFile;
begin
  AssignFile(F,EditResult.Text);
  ReWrite(F);
  Writeln(F,GetFileInf(Form1.Caption,ParamStr(0)));
  Writeln(F,'r'+#13+#10);
  Writeln(F,GetFileInf('  '+LabelSrc.Caption,EditSrc.Text));
  Writeln(F,GetFileInf('  '+LabelDst.Caption,EditDst.Text));
  Writeln(F,'  r@'+#13+#10+'    '+RadiogroupType.items[RadiogroupType.ItemIndex]);
  Writeln(F,#13+#10+'r');
  CloseFile(F);
end;

function TForm1.GetFileInf(Title, FileName: String): String;
var
  R: TSearchRec;
begin
  FindFirst(FileName,faAnyFIle,R);
  result := FormatDateTime('yyyy-mm-dd hh:nn:ss'
                      ,FileDateToDateTime(R.Time));
  if CheckExpandUNCName.Checked = True then
    FileName := ExpandUNCFileName(FileName);

  result := Title+#13+#10+'    '+AnsiQuotedStr(FileName,#34)+#13+#10
            +Format('    (time: %s  size: %u)',[result,R.Size])
            +#13+#10;
  FindClose(R);
end;

procedure TForm1.ButtonCloseClick(Sender: TObject);
begin
  close;
end;

end.

